﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;
using Microsoft.SharePoint.Client;

namespace LifecycleAppWeb
{
    public class AppEventReceiver : IRemoteEventService
    {
        public SPRemoteEventResult ProcessEvent(RemoteEventProperties properties)
        {
            SPRemoteEventResult result = new SPRemoteEventResult();
            result.Status = SPRemoteEventServiceStatus.Continue;

            if (!System.Diagnostics.EventLog.SourceExists("App LifeCycle Events"))
                System.Diagnostics.EventLog.CreateEventSource(
                "App LifeCycle Events",
                "Application");

            System.Diagnostics.EventLog.WriteEntry(
              "App LifeCycle Events",
              "(Process Event) " + properties.EventType.ToString());

            return result;
        }

        public void ProcessOneWayEvent(RemoteEventProperties properties)
        {
            if (!System.Diagnostics.EventLog.SourceExists("App LifeCycle Events"))
                System.Diagnostics.EventLog.CreateEventSource(
                "App LifeCycle Events",
                "Application");

            System.Diagnostics.EventLog.WriteEntry(
              "App LifeCycle Events",
              "(Process One-Way Event) " + properties.EventType.ToString());

        }
    }
}
