﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint.Client;

namespace AutohostedOAuthWeb.Pages
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            var contextToken = TokenHelper.GetContextTokenFromRequest(Page.Request);
            var hostWeb = Page.Request["SPHostUrl"];

            using (var clientContext = TokenHelper.GetClientContextWithContextToken(hostWeb, contextToken, Request.Url.Authority))
            {
                clientContext.Load(clientContext.Web);

                List list = clientContext.Web.Lists.GetByTitle("Contacts");
                clientContext.Load(list);

                StringBuilder caml = new StringBuilder();
                caml.Append("<View><Query><OrderBy/></Query>");
                caml.Append("<ViewFields><FieldRef Name='ID'/><FieldRef Name='FirstName'/>");
                caml.Append("<FieldRef Name='Title'/><FieldRef Name='WorkPhone'/></ViewFields>");
                caml.Append("<RowLimit>100</RowLimit></View>");

                CamlQuery query = new CamlQuery();
                query.ViewXml = caml.ToString();
                Microsoft.SharePoint.Client.ListItemCollection listItems = list.GetItems(query);
                clientContext.Load(listItems);
                clientContext.ExecuteQuery();

                List<Contact> contacts = new List<Contact>();

                foreach (Microsoft.SharePoint.Client.ListItem listItem in listItems)
                {
                    Contact contact = new Contact()
                    {
                        Id = listItem["ID"].ToString(),
                        LastName = listItem["Title"].ToString(),
                        FirstName = listItem["FirstName"].ToString(),
                        WorkPhone = listItem["WorkPhone"].ToString()
                    };
                    contacts.Add(contact);
                }

                contactsGrid.DataSource = contacts;
                contactsGrid.DataBind();
            }

        }
    }
}