﻿window.Wingtip = window.Wingtip || {};
Wingtip.CrossDomain = function () {

    load = function () {
        var appweburl = getQueryStringParameter("SPSourceAppUrl");
        var executor = new SP.RequestExecutor(appweburl);

        executor.executeAsync(
        {
            url:
            appweburl +
            "/_api/web/lists/getByTitle('Contacts')/items/" +
                            "?$select=Id,FirstName,Title,WorkPhone,Email" +
                            "&$orderby=Title,FirstName",
            method: "GET",
            headers: { "Accept": "application/json;odata=verbose" },
            success: successHandler,
            error: errorHandler
        })
    },

    successHandler = function (data) {

        var jsonObject = JSON.parse(data.body);
        var results = jsonObject.d.results;

        var contacts = Wingtip.ContactViewModel.get_contacts();
        contacts.removeAll();

        for (var i = 0; i < results.length; i++) {
            contacts.push(
                new Wingtip.Contact(
                results[i].Title,
                results[i].FirstName,
                results[i].WorkPhone,
                results[i].Email));
        }

        ko.applyBindings(Wingtip.ContactViewModel, document.getElementById("resultsTable"));

    },

    errorHandler = function (data, errorCode, errorMessage) {
        alert("Error calling cross-domain: " + errorMessage);
    },

    getQueryStringParameter = function (paramToRetrieve) {
        var params = document.URLUnencoded.split("?")[1].split("&");
        var strParams = "";
        for (var i = 0; i < params.length; i = i + 1) {
            var singleParam = params[i].split("=");
            if (singleParam[0] == paramToRetrieve)
                return singleParam[1];
        }
    }

    return {
        load: load
    }

}()

$(document).ready(function () {
    Wingtip.CrossDomain.load();
});