﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FeedDeckAppWeb.Models;
using Microsoft.SharePoint.Client;
using Microsoft.SharePoint.Client.Social;
//using Microsoft.SharePoint.Client.Microfeed;
using Microsoft.SharePoint.Client.UserProfiles;

namespace FeedDeckAppWeb.Controllers
{
    public class FeedController : Controller
    {

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult ShowThreads(string SPHostUrl, string SPHostTitle, string Account)
        {
            using (ClientContext ctx = new ClientContext(SPHostUrl))
            {
                
                //Get properties for the person
                PeopleManager peopleManager = new PeopleManager(ctx);
                PersonProperties personProps = peopleManager.GetPropertiesFor(Account);

                ctx.Load(personProps, o => o.DisplayName, o => o.AccountName);
                ctx.ExecuteQuery();

                // Get feed for the person
                SocialFeedManager socialFeedManager = new SocialFeedManager(ctx);
                ctx.Load(socialFeedManager);

                SocialFeedOptions feedOptions = new SocialFeedOptions();
                ClientResult<SocialFeed> feed = socialFeedManager.GetFeed(SocialFeedType.Everyone, feedOptions);
                ctx.ExecuteQuery();

                //Collect all the posts
                List<FeedThread> feedThreads = new List<FeedThread>();

                for (int i = 0; i < feed.Value.Threads.Length; i++)
                {
                    SocialThread thread = feed.Value.Threads[i];
                    FeedThread feedThread = new FeedThread();
                    feedThread.Id = i;
                    feedThread.Poster = personProps.DisplayName;
                    feedThread.ThreadId = thread.Id;
                    feedThread.ThreadText = thread.RootPost.Text;
                    feedThreads.Add(feedThread);
                }

                //Send posts to view
                ViewBag.FeedThreads = feedThreads;
                ViewBag.SPHostUrl = SPHostUrl;
                ViewBag.SPHostTitle = SPHostTitle;
                ViewBag.Account = Account;
            }

            return View();
        }

        public ActionResult Reply(string SPHostUrl, string SPHostTitle, string Account, string ThreadId)
        {
            using (ClientContext ctx = new ClientContext(SPHostUrl))
            {
                SocialFeedManager socialFeedManager = new SocialFeedManager(ctx);
                ctx.Load(socialFeedManager);
                
                SocialPostCreationData postCreationData = new SocialPostCreationData();
                postCreationData.ContentText = "Great post!";
                socialFeedManager.CreatePost(ThreadId, postCreationData);
                ctx.ExecuteQuery();
            }

            return View();
        }
    }
}
