﻿window.Wingtip = window.Wingtip || {}
window.Wingtip.Contact = function (ln, fn, ph) {

    //private members
    var lname = 'undefined',
        fname = 'undefined',
        phone = 'undefined',
        set_lname = function (v) { lname = v; },
        get_lname = function () { return lname; },
        set_fname = function (v) { fname = v; },
        get_fname = function () { return fname; },
        set_phone = function (v) { phone = v; },
        get_phone = function () { return phone; };


    //Constructor
    lname = ln;
    fname = fn;
    phone = ph;

    //public interface
    return {
        set_lname: set_lname,
        get_lname: get_lname,
        set_fname: set_fname,
        get_fname: get_fname,
        set_phone: set_phone,
        get_phone: get_phone
    };
}

window.Wingtip.ContactViewModel = function () {

    //private members
    var contacts = ko.observableArray(),
        get_contacts = function () { return contacts; },

        load = function () {
            $.ajax(
                    {
                        url: _spPageContextInfo.webServerRelativeUrl +
                            "/_api/web/lists/getByTitle('Contacts')/items/" +
                            "?$select=Id,FirstName,Title,WorkPhone" +
                            "&$orderby=Title,FirstName",
                        type: "GET",
                        headers: {
                            "accept": "application/json;odata=verbose",
                        },
                        success: onSuccess,
                        error: onError
                    }
                );
        },

        onSuccess = function (data) {
            var results = data.d.results;

            contacts.removeAll();

            for (var i = 0; i < results.length; i++) {
                contacts.push(
                    new Wingtip.Contact(
                    results[i].Title,
                    results[i].FirstName,
                    results[i].WorkPhone));
            }

        },

        onError = function (err) {
            alert(JSON.stringify(err));
        };


    //public interface
    return {
        load: load,
        get_contacts: get_contacts
    };

}();
